#include "assert.h"

#include "stdio.h"
#include "string.h"
#include "stdlib.h"
#include "math.h"

#include "SDL.h"
#include "SDL_rotozoom.h"
#include "SDL_ttf.h"
#include "SDL_mixer.h"

#include "BList.h"

#include "auxiliar.h"

#include "samples.h"
#include "animscript.h"
#include "valuescript.h"
#include "conditionscript.h"
#include "actionscript.h"
#include "variables.h"
#include "mog2.h"
#include "object.h"
#include "activeobject.h"
#include "activeroom.h"
#include "activeMAP.h"
#include "activemog2.h"
#include "ActiveINTERFACE.h"

#include "samples.h"

#ifdef KITSCHY_DEBUG_MEMORY 
#include "debug_memorymanager.h"
#endif

extern int surface_flags;

void ActiveOBJECT::gw_draw(int sx,int sy,SDL_Surface *sfc,SDL_Rect *vp)
{
	/* Draw a Game window object: */ 		
	if (gw_dx!=0 && gw_dy!=0) {
		ActiveROOM *f_room=0;		
		SDL_Rect gw_vp,old_clip,new_clip;

		if (!gw_focusing.EmptyP()) {
			f_room=gw_focusing[0]->room;
		} /* if */ 

		if (f_room!=0) {
			SDL_GetClipRect(sfc,&old_clip);

			gw_vp.x=int(vp->x+x);
			gw_vp.y=int(vp->y+y);
			gw_vp.w=gw_dx;
			gw_vp.h=gw_dy;
			new_clip.x=vp->x;
			new_clip.y=vp->y;
			new_clip.w=vp->w;
			new_clip.h=vp->h;
			if (new_clip.x<gw_vp.x) {
				new_clip.w-=gw_vp.x-new_clip.x;
				new_clip.x=gw_vp.x;
			} /* if */ 
			if (new_clip.y<gw_vp.y) {
				new_clip.h-=gw_vp.y-new_clip.y;
				new_clip.y=gw_vp.y;
			} /* if */ 
			if (new_clip.x+new_clip.w>gw_vp.x+gw_vp.w) new_clip.w=(gw_vp.x+gw_vp.w)-new_clip.x;
			if (new_clip.y+new_clip.h>gw_vp.y+gw_vp.h) new_clip.h=(gw_vp.y+gw_vp.h)-new_clip.y;

			SDL_SetClipRect(sfc,&new_clip);
			if (gw_scale==100) {
				SDL_Rect r;
				r.x=gw_min_hs_x;
				r.y=gw_min_hs_y;
				r.w=gw_max_hs_x-gw_min_hs_x;
				r.h=gw_max_hs_y-gw_min_hs_y;
				f_room->draw(sfc,new_clip,&gw_focusing,&r);
				gw_last_viewx=f_room->viewx;
				gw_last_viewy=f_room->viewy;
			} else {
				SDL_Rect r,r2,r3;
				float zoom=float(gw_scale)/100.0F;
				r.x=0;
				r.y=0;
				r.w=int(gw_dx/zoom);
				r.h=int(gw_dy/zoom);

				if (r.w>f_room->room->get_dx()*TILESIZE) r.w=f_room->room->get_dx()*TILESIZE;
				if (r.h>f_room->room->get_dy()*TILESIZE) r.h=f_room->room->get_dy()*TILESIZE;

				SDL_Surface *tmp=SDL_CreateRGBSurface(surface_flags,r.w,r.h,32,0,0,0,0);
				SDL_Surface *tmp2;
				SDL_FillRect(tmp,0,0);
				r3.x=int(gw_min_hs_x);
				r3.y=int(gw_min_hs_y);
				r3.w=int((gw_max_hs_x-gw_min_hs_x));
				r3.h=int((gw_max_hs_y-gw_min_hs_y));
				f_room->draw(tmp,r,&gw_focusing,&r3);
				gw_last_viewx=f_room->viewx;
				gw_last_viewy=f_room->viewy;

				if (zoom>=2.0) tmp2=zoomSurface(tmp, zoom, zoom, 0);
						  else tmp2=zoomSurface(tmp, zoom, zoom, 1);

				r2.x=x+gw_dx/2-tmp2->w/2;
				r2.y=y+gw_dy/2-tmp2->h/2;
				r2.w=tmp2->w;
				r2.h=tmp2->h;
				SDL_BlitSurface(tmp2,0,sfc,&r2);

				SDL_FreeSurface(tmp2);
				SDL_FreeSurface(tmp);
			} /* if */ 

			/* Drawing modes: */ 
			switch(dm_drawing_mode) {
			case 0:
					break;
					/* SHADED: */ 
			case 1: surface_shader(sfc,float(dm_factor)/100.0F,dm_color1_r,dm_color1_g,dm_color1_b,dm_color1_a,&new_clip);
					break;
					/* BICOLOR: */ 
			case 2: surface_bicolor(sfc,float(dm_factor)/100.0F,dm_color1_r,dm_color1_g,dm_color1_b,dm_color1_a,dm_color2_r,dm_color2_g,dm_color2_b,dm_color2_a,&new_clip);
					break;
					/* reflection: */ 
			case 3: 
					break;
					/* refraction: */ 
			case 4: 
					break;
			} /* switch */ 
			

			SDL_SetClipRect(sfc,&old_clip);
		} /* if */ 
	} /* if */ 

} /* ActiveOBJECT::gw_Draw */ 

